/* eslint-disable */
let deBtn = document.createElement('span');
const shadowRoot = deBtn.attachShadow({mode: 'closed'})
const shadowDiv = document.createElement('div');
shadowDiv.innerText = 'DeNet';
shadowDiv.id = 'de-btn';
shadowDiv.style.cssText = 'width:220px;height: 52px;text-align:center;line-height:52px;margin-bottom: 4px;margin-top: 4px;background: linear-gradient(274.8deg, #FF9900 -3.69%, #BD00FF 69.71%, #00F0FF 122.65%);color:#fff;font-size:15px;font-weight:700;border-radius:100px;cursor: pointer;';
shadowRoot.appendChild(shadowDiv);


const deBtn1 = document.createElement('div');
const smallDeBtnStyle = 'width:30px;height: 30px;text-align:center;line-height:30px;background: linear-gradient(274.8deg, #FF9900 -3.69%, #BD00FF 69.71%, #00F0FF 122.65%);color:#fff;font-size:12px;font-weight:500;border-radius:4px;cursor: pointer;';
deBtn1.innerText = 'De';
deBtn1.id = 'de-btn1';
deBtn1.style.cssText = smallDeBtnStyle;

const deBtn2 = document.createElement('div');
deBtn2.innerText = 'De';
deBtn2.id = 'de-btn2';
deBtn2.style.cssText = smallDeBtnStyle;

let tweetBtn;

deBtn.addEventListener('click', () => {
	showGiveDialog();
})
deBtn1.addEventListener('click', () => {
	showGiveDialog();
})
deBtn2.addEventListener('click', () => {
	showGiveDialog();
})

document.addEventListener('DOMContentLoaded', function () {
	setTimeout(() => {
		addDeNetBtn(deBtn);
		addIframe();
		
		tweetBtn = document.querySelector('a[data-testid="SideNav_NewTweet_Button"]');
		tweetBtn.addEventListener('click', function () {
			setTimeout(() => {
				let dialogScheduleBtn = getScheduleDom(true);
				addDeNetEditBtn(dialogScheduleBtn, deBtn2);
			}, 800)
		})
	}, 1000)
})

window.addEventListener('message', function (event) {
	if (event.data && event.data.actionType) {
		let iframe = document.getElementById('iframe-test');
		switch (event.data.actionType) {
			case "showIframe":
				iframe.style.display = 'block';
				break;
			case "hideIframe":
				iframe.style.display = 'none';
				break;
			case "showTwitterPublishDialog":
				// iframe.style.display = 'none';
				tweetBtn.click();
				publishTweetEvent();
				break;
		}
	}
	console.log('message',event);
});

function publishTweetEvent () {
	let publishTweetBtn = document.querySelector('div[role="dialog"]').querySelector('div[data-testid="tweetButton"]');
	publishTweetBtn.addEventListener('click', function () {
		setTimeout(() => {
			let twitterArtId = getTwitterArtId();
		}, 1000)
	});
}

function addDeNetEditBtn (parent, dom, isClick = false) {
	setTimeout(() => {
		if (parent) {
			parent.parentNode.insertBefore(dom, parent.nextSibling);
		} else {
			setTimeout(() => {
				parent = getScheduleDom(isClick);
				parent.parentNode.insertBefore(dom, parent.nextSibling);
			}, 1000)
		}
	})
}

function addDeNetBtn (dom) {
	setTimeout(() => {
		let node = document.querySelector('header[role="banner"]').querySelector('.r-1habvwh');
		if (node) {
			node.appendChild(dom);
		}
		
		let dialogScheduleBtn = getScheduleDom(false);
		addDeNetEditBtn(dialogScheduleBtn, deBtn1);
	}, 1000)
}

function getScheduleDom (isDialogInner = false) {
	let scheduleBtn;
	if (isDialogInner) {
		scheduleBtn = document.querySelector('div[role="dialog"]').querySelector('[data-testid="createPollButton"]');
	} else {
		// eslint-disable-next-line no-unused-vars
		let toolBar = document.querySelector('div[data-testid="toolBar"]');
		if (toolBar) {
			scheduleBtn = toolBar.querySelector('div[data-testid="createPollButton"]');
		}
	}
	return scheduleBtn;
}

function addIframe () {
	// let span = document.createElement('span');
	// const shadowRoot = span.attachShadow({mode: 'closed'})
	let iframe = document.createElement('iframe');
	iframe.src = chrome.runtime.getURL('/iframe/test.html')
	iframe.id = 'iframe-test'
	iframe.style.cssText = 'position:fixed;top:0px;right:0;display:block; width:100%;height:100%;z-index:0; border: medium none;display:none';
	// shadowRoot.appendChild(iframe);
	// document.body.appendChild(span)
	document.getElementById('layers').appendChild(iframe)
}

function getTwitterArtId () {
	let firstTwitterArtId = document.querySelector('article[data-testid="tweet"]').querySelector('a[dir="auto"]').getAttribute('href');
	
	return firstTwitterArtId;
}

function showGiveDialog() {
	document.getElementById('iframe-test').contentWindow.postMessage({actionType : 'showGiveDialog'}, '*');
}

function setPublishContent (content) {
	setTimeout(() => {
		document.execCommand("insertText", false, content);
	});
}


/* setInterval(() => {
	let toolBar = document.querySelector('div[data-testid="toolBar"]');
	let innerDeIcon = document.getElementById('de-icon');
	if (toolBar && !innerDeIcon) {
		// let dialogScheduleBtn = getScheduleDom(false);
		// addDeNetEditBtn(dialogScheduleBtn, deBtn1);
	}
}, 800) */
